 // ************************************************************
 //  This unit has been created using DDOWizard 0.9.90
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 08.01.2007 08:07:54
 // ************************************************************

unit uClientCallbackCallbackListener_Proxy;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TNotificationEvent = procedure (Sender: TDDOProxyBase; GUID: String) of object;

type
  TClientCallbackCallbackListener = class(TDDOProxyBase)
  private
    procedure _Notification(GUID: String; Callback: TMethod);
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
    function Notification(DateTime: TDateTime; DataString: String; Callback: TNotificationEvent): String;
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TClientCallbackCallbackListener.GetVersion: String;
begin
  Result := '{22D367A4-E5CA-4880-9654-1C5017203F63}';
end;

function TClientCallbackCallbackListener.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TClientCallbackCallbackListener.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
    0: _Notification(GUID, Method);
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TClientCallbackCallbackListener._Notification(GUID: String; Callback: TMethod);
begin
  TNotificationEvent(Callback)(Originator, GUID);
end;

function TClientCallbackCallbackListener.Notification(DateTime: TDateTime; DataString: String; Callback: TNotificationEvent): String;
begin
  PrepareCall('Notification');
  SetParam('DateTime', DateTime, True);
  SetParam('DataString', DataString, False);
  Result := AddEvent(SendAsyncRequest, TMethod(Callback), 0);
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
