// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Ddobroker.pas' rev: 10.00

#ifndef DdobrokerHPP
#define DdobrokerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Scktcomp.hpp>	// Pascal unit
#include <Ddotimer.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Ddobase.hpp>	// Pascal unit
#include <Ddoconsts.hpp>	// Pascal unit
#include <Ddoshared.hpp>	// Pascal unit
#include <Ddoserver.hpp>	// Pascal unit
#include <Ddosockets.hpp>	// Pascal unit
#include <Ddoclient.hpp>	// Pascal unit
#include <Ddosystem.hpp>	// Pascal unit
#include <Uddobrokerinfo_proxy.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ddobroker
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TServerState { ssActive, ssInactive };
#pragma option pop

class DELPHICLASS TServerItem;
class DELPHICLASS TServerList;
class DELPHICLASS TClientBrokerSocket;
class PASCALIMPLEMENTATION TServerItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FHost;
	int FPort;
	Contnrs::TObjectList* FSockets;
	TServerState FState;
	TServerList* __fastcall GetCollection(void);
	HIDESBASE void __fastcall SetCollection(TServerList* Value);
	void __fastcall SetHost(const AnsiString Value);
	void __fastcall SetPort(int Value);
	void __fastcall SetState(TServerState Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayName();
	
public:
	__fastcall virtual TServerItem(Classes::TCollection* Collection);
	__fastcall virtual ~TServerItem(void);
	void __fastcall Put(TClientBrokerSocket* Socket);
	TClientBrokerSocket* __fastcall Get(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TServerList* Collection = {read=GetCollection, write=SetCollection};
	__property TServerState State = {read=FState, write=SetState, nodefault};
	
__published:
	__property AnsiString Host = {read=FHost, write=SetHost};
	__property int Port = {read=FPort, write=SetPort, nodefault};
};


typedef DynamicArray<TServerItem* >  TServerItemArray;

class PASCALIMPLEMENTATION TServerList : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
public:
	TServerItem* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TComponent* FOwner;
	Ddosystem::TDDOCriticalSection* FLock;
	void __fastcall CheckLock(void);
	HIDESBASE TServerItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TServerItem* Value);
	
public:
	TServerList* __fastcall LockList(void);
	void __fastcall UnlockList(void);
	__fastcall TServerList(Classes::TComponent* Owner);
	__fastcall virtual ~TServerList(void);
	HIDESBASE TServerItem* __fastcall Add(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
	HIDESBASE TServerItem* __fastcall FindItemID(int ID);
	HIDESBASE TServerItem* __fastcall Insert(int Index);
	TServerItem* __fastcall Put(TClientBrokerSocket* Socket);
	TServerItem* __fastcall GetServer(const AnsiString Host, int Port)/* overload */;
	TServerItem* __fastcall GetServer(const AnsiString DisplayName)/* overload */;
	TServerItemArray __fastcall ActiveServers();
	__property TServerItem* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
};


#pragma option push -b-
enum TSocketState { stOpen, stClosed, stFailed };
#pragma option pop

class PASCALIMPLEMENTATION TClientBrokerSocket : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Scktcomp::TClientSocket* FSocket;
	TSocketState FState;
	TServerItem* FServer;
	void __fastcall CreateSocket(void);
	
protected:
	__property Scktcomp::TClientSocket* Socket = {read=FSocket};
	
public:
	__fastcall TClientBrokerSocket(TServerItem* Server);
	__fastcall virtual ~TClientBrokerSocket(void);
	void __fastcall Connect(void);
	void __fastcall Disconnect(void);
	void __fastcall Reconnect(void);
	__property TServerItem* Server = {read=FServer};
	__property TSocketState State = {read=FState, nodefault};
	void __fastcall WriteData(const AnsiString AString);
	AnsiString __fastcall ReadData(int TimeOut, Ddosockets::TReadDataCallback Callback);
};


typedef void __fastcall (__closure *TThreadReadDataEvent)(System::TObject* Sender, Classes::TThread* Thread, int Size, int Expected);

typedef void __fastcall (__closure *TExceptionEvent)(System::TObject* Sender, Sysutils::Exception* E);

typedef void __fastcall (__closure *TDataReceivedEvent)(System::TObject* Sender, AnsiString &Data);

typedef void __fastcall (__closure *TServerConnectEvent)(System::TObject* Sender, TServerItem* Server);

class DELPHICLASS TDDOBrokerThread;
typedef void __fastcall (__closure *TClientConnectEvent)(System::TObject* Sender, TDDOBrokerThread* Client);

#pragma option push -b-
enum TBrokerMethod { bmRandom, bmRoundRobin };
#pragma option pop

typedef TMetaClass* TSelectServerStrategyClass;

class DELPHICLASS TSelectServerStrategy;
class PASCALIMPLEMENTATION TSelectServerStrategy : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	virtual TBrokerMethod __fastcall GetMethod(void) = 0 ;
	virtual TClientBrokerSocket* __fastcall Execute(TServerItemArray ServerList, TDDOBrokerThread* Client) = 0 ;
	
public:
	__fastcall virtual TSelectServerStrategy(void);
	TClientBrokerSocket* __fastcall GetSocket(TServerList* ServerList, TDDOBrokerThread* Client);
	__property TBrokerMethod Method = {read=GetMethod, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSelectServerStrategy(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSelectRandomStrategy;
class PASCALIMPLEMENTATION TSelectRandomStrategy : public TSelectServerStrategy 
{
	typedef TSelectServerStrategy inherited;
	
protected:
	virtual TBrokerMethod __fastcall GetMethod(void);
	virtual TClientBrokerSocket* __fastcall Execute(TServerItemArray ServerList, TDDOBrokerThread* Client);
public:
	#pragma option push -w-inl
	/* TSelectServerStrategy.Create */ inline __fastcall virtual TSelectRandomStrategy(void) : TSelectServerStrategy() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSelectRandomStrategy(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSelectRoundRobinStrategy;
class PASCALIMPLEMENTATION TSelectRoundRobinStrategy : public TSelectServerStrategy 
{
	typedef TSelectServerStrategy inherited;
	
private:
	int FCurrent;
	
protected:
	virtual TBrokerMethod __fastcall GetMethod(void);
	virtual TClientBrokerSocket* __fastcall Execute(TServerItemArray ServerList, TDDOBrokerThread* Client);
public:
	#pragma option push -w-inl
	/* TSelectServerStrategy.Create */ inline __fastcall virtual TSelectRoundRobinStrategy(void) : TSelectServerStrategy() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSelectRoundRobinStrategy(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDDOBroker;
class PASCALIMPLEMENTATION TDDOBroker : public Ddobase::TDDOComponent 
{
	typedef Ddobase::TDDOComponent inherited;
	
private:
	bool FActive;
	int FPort;
	int FCacheSize;
	int FTimeOut;
	TServerList* FServerList;
	Ddosockets::TDDOServerSocket* FSocket;
	TSelectServerStrategy* FStrategy;
	Contnrs::TObjectList* FProxies;
	TServerConnectEvent FOnServerConnect;
	TServerConnectEvent FOnServerDisconnect;
	TClientConnectEvent FOnClientConnect;
	TClientConnectEvent FOnClientDisconnect;
	TDataReceivedEvent FOnRequestReceived;
	TDataReceivedEvent FResultReceived;
	TExceptionEvent FOnException;
	TThreadReadDataEvent FThreadReadData;
	Ddotimer::TDDOTimer* FReconnectTimer;
	bool __fastcall GetActive(void);
	int __fastcall GetPort(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetPort(int Value);
	void __fastcall SetTimeOut(int Value);
	void __fastcall CreateSocket(void);
	void __fastcall GetThread(System::TObject* Sender, Scktcomp::TServerClientWinSocket* ClientSocket, Scktcomp::TServerClientThread* &SocketThread);
	TClientBrokerSocket* __fastcall AcquireSocket(TDDOBrokerThread* Client);
	void __fastcall ReleaseSocket(TClientBrokerSocket* Socket);
	void __fastcall SetServerList(TServerList* Value);
	void __fastcall SetMethod(TBrokerMethod Value);
	TBrokerMethod __fastcall GetMethod(void);
	int __fastcall GetActiveConnections(void);
	int __fastcall GetActiveThreads(void);
	int __fastcall GetServerConnections(void);
	int __fastcall GetThreadCacheSize(void);
	void __fastcall SetThreadCacheSize(int Value);
	int __fastcall GetServerCount(void);
	void __fastcall ReadDataCallback(TDDOBrokerThread* Thread, int Size, int Expected);
	TServerItem* __fastcall GetServer(Uddobrokerinfo_proxy::TDDOBrokerInfoProxyStub* Proxy);
	void __fastcall InitializeProxies(void);
	void __fastcall FinalizeProxies(void);
	void __fastcall PingServers(void);
	void __fastcall PingNotification(Ddoclient::TDDOProxyBase* Sender, AnsiString GUID);
	void __fastcall ServerNotification(System::TObject* Sender, bool ServerActive);
	int __fastcall GetReconnectInterval(void);
	void __fastcall SetReconnectInterval(int Value);
	void __fastcall DoReconnect(System::TObject* Sender);
	
protected:
	virtual void __fastcall Loaded(void);
	void __fastcall SetSelectStrategy(TMetaClass* Strategy);
	void __fastcall ClientConnect(TDDOBrokerThread* Thread);
	void __fastcall ClientDisconnect(TDDOBrokerThread* Thread);
	void __fastcall ServerConnect(TServerItem* Server);
	void __fastcall ServerDisconnect(TServerItem* Server);
	void __fastcall HandleException(Sysutils::Exception* E);
	void __fastcall RequestReceived(AnsiString &Data);
	void __fastcall ResultReceived(AnsiString &Data);
	__property Ddosockets::TDDOServerSocket* Socket = {read=FSocket};
	
public:
	__fastcall virtual TDDOBroker(Classes::TComponent* Owner);
	__fastcall virtual ~TDDOBroker(void);
	__property int ClientConnections = {read=GetActiveConnections, nodefault};
	__property int ClientThreads = {read=GetActiveThreads, nodefault};
	__property int ServerCount = {read=GetServerCount, nodefault};
	__property int ServerConnections = {read=GetServerConnections, nodefault};
	
__published:
	__property bool Active = {read=GetActive, write=SetActive, nodefault};
	__property int Port = {read=GetPort, write=SetPort, default=6666};
	__property TBrokerMethod Method = {read=GetMethod, write=SetMethod, nodefault};
	__property int ReconnectInterval = {read=GetReconnectInterval, write=SetReconnectInterval, nodefault};
	__property int TimeOut = {read=FTimeOut, write=SetTimeOut, nodefault};
	__property int ThreadCacheSize = {read=GetThreadCacheSize, write=SetThreadCacheSize, default=15};
	__property TServerConnectEvent OnServerConnect = {read=FOnServerConnect, write=FOnServerConnect};
	__property TServerConnectEvent OnServerDisconnect = {read=FOnServerDisconnect, write=FOnServerDisconnect};
	__property TClientConnectEvent OnClientConnect = {read=FOnClientConnect, write=FOnClientConnect};
	__property TClientConnectEvent OnClientDisconnect = {read=FOnClientDisconnect, write=FOnClientDisconnect};
	__property TExceptionEvent OnException = {read=FOnException, write=FOnException};
	__property TDataReceivedEvent OnRequestReceived = {read=FOnRequestReceived, write=FOnRequestReceived};
	__property TDataReceivedEvent OnResultReceived = {read=FResultReceived, write=FResultReceived};
	__property TThreadReadDataEvent OnThreadReadData = {read=FThreadReadData, write=FThreadReadData};
	__property TServerList* ServerList = {read=FServerList, write=SetServerList};
};


class PASCALIMPLEMENTATION TDDOBrokerThread : public Ddosockets::TDDOServerClientThread 
{
	typedef Ddosockets::TDDOServerClientThread inherited;
	
private:
	TDDOBroker* FBroker;
	AnsiString FData;
	Sysutils::Exception* FException;
	void __fastcall RequestReceived(void);
	void __fastcall ResultReceived(void);
	void __fastcall ReadDataCallback(int Size, int Expected);
	
protected:
	virtual void __fastcall HandleException(void);
	virtual void __fastcall HandleRequest(void);
	__property TDDOBroker* Broker = {read=FBroker};
	
public:
	__fastcall TDDOBrokerThread(Scktcomp::TServerClientWinSocket* Socket, TDDOBroker* Broker);
public:
	#pragma option push -w-inl
	/* TServerClientThread.Destroy */ inline __fastcall virtual ~TDDOBrokerThread(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Ddobroker */
using namespace Ddobroker;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Ddobroker
