// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DDOServer.pas' rev: 6.00

#ifndef DDOServerHPP
#define DDOServerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <DDOUsage.hpp>	// Pascal unit
#include <DDOSystem.hpp>	// Pascal unit
#include <DDODocument.hpp>	// Pascal unit
#include <DDOBase.hpp>	// Pascal unit
#include <DDOShared.hpp>	// Pascal unit
#include <DDOConsts.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <TypInfo.hpp>	// Pascal unit
#include <DDOOpenSSL.hpp>	// Pascal unit
#include <ScktComp.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <DDOSockets.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ddoserver
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TDDOSessionData;
class PASCALIMPLEMENTATION TDDOSessionData : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Variant FValue;
	void __fastcall SetValue(const Variant &NewValue);
	
public:
	__fastcall TDDOSessionData(const Variant &AValue);
	__fastcall virtual ~TDDOSessionData(void);
	__property Variant Value = {read=FValue, write=SetValue};
};


class DELPHICLASS TDDOSession;
class PASCALIMPLEMENTATION TDDOSession : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TStrings* FData;
	AnsiString FSessionID;
	System::TDateTime FValidUntil;
	Ddosystem::TDDOCriticalSection* FLock;
	Variant __fastcall GetValue(AnsiString Key);
	void __fastcall SetValue(AnsiString Key, const Variant &Value);
	
protected:
	__property System::TDateTime ValidUntil = {read=FValidUntil};
	__property AnsiString SessionID = {read=FSessionID};
	
public:
	__fastcall TDDOSession(AnsiString SessionID);
	__fastcall virtual ~TDDOSession(void);
	void __fastcall Lock(void);
	void __fastcall Unlock(void);
	bool __fastcall Exists(AnsiString Key);
	void __fastcall Clear(void);
	__property Variant Value[AnsiString Key] = {read=GetValue, write=SetValue};
};


class DELPHICLASS TDDOListenerThread;
class DELPHICLASS TDDOListener;
#pragma option push -b-
enum TClientAccess { caSerialized, caMultiThreaded };
#pragma option pop

typedef void __fastcall (__closure *TClientException)(System::TObject* Sender, Sysutils::Exception* E, const AnsiString Method);

class DELPHICLASS TDDOStubBase;
typedef void __fastcall (__closure *TStubCreatedEvent)(System::TObject* Sender, TDDOStubBase* Stub);

typedef TMetaClass*TDDOStubClass;

typedef void __fastcall (__closure *TEnumStubCallback)(TDDOStubBase* Stub, int UserData, bool &Continue);

class PASCALIMPLEMENTATION TDDOListener : public Ddobase::TDDOComponent 
{
	typedef Ddobase::TDDOComponent inherited;
	
private:
	bool FKeepALive;
	bool FActive;
	int FPort;
	int FCacheSize;
	int FRequests;
	Ddosockets::TDDOServerSocket* FSocket;
	Ddobase::TRequestEvent FOnRequestReceived;
	Classes::TList* FClasses;
	Ddobase::TResultEvent FOnRequestProcessed;
	TClientAccess FClientAccess;
	int FMaxThreads;
	TClientException FOnClientException;
	Ddobase::TDataEvent FOnDataEvent;
	Byte FThreadTimeOut;
	Byte FSessionTimeOut;
	Ddosystem::TDDOCriticalSection* FCritical;
	Classes::TNotifyEvent FOnActivate;
	Classes::TNotifyEvent FOnDeActivate;
	TStubCreatedEvent FOnStubCreated;
	bool FUseSSL;
	bool FCheckVersion;
	bool __fastcall GetActive(void);
	int __fastcall GetActiveConnections(void);
	int __fastcall GetActiveThreads(void);
	Scktcomp::TCustomWinSocket* __fastcall GetConnection(int Index);
	int __fastcall GetIdleThreads(void);
	int __fastcall GetThreadCacheSize(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetPort(int Value);
	void __fastcall SetThreadCacheSize(int Value);
	TMetaClass* __fastcall FindStubClass(Ddodocument::TDDODocument* Request);
	int __fastcall GetClassCount(void);
	TMetaClass* __fastcall GetStubClass(int Index);
	void __fastcall SetClientAccess(TClientAccess Value);
	void __fastcall CompareVersions(TMetaClass* StubClass, Ddodocument::TDDODocument* Request);
	int __fastcall GetActiveStubs(void);
	void __fastcall CreateSocket(void);
	void __fastcall NotifyBroker(bool Active);
	void __fastcall DoNotification(TDDOStubBase* Stub, int UserData, bool &Continue);
	/*         class method */ static bool __fastcall ContinueTrial(TMetaClass* vmt);
	void __fastcall SetUseSSL(const bool Value);
	
protected:
	void __fastcall CleanupThreads(void);
	void __fastcall DoActivate(void);
	void __fastcall DoDeActivate(void);
	void __fastcall DoRequestProcessed(Ddodocument::TDDODocument* Result);
	void __fastcall DoRequestReceived(Ddodocument::TDDODocument* Request);
	void __fastcall DoClientException(Sysutils::Exception* E, const AnsiString Method);
	void __fastcall DoDataEvent(bool Sending, AnsiString &Data);
	void __fastcall GetThread(System::TObject* Sender, Scktcomp::TServerClientWinSocket* ClientSocket, Scktcomp::TServerClientThread* &SocketThread);
	virtual TDDOListenerThread* __fastcall CreateThread(Scktcomp::TServerClientWinSocket* ClientSocket);
	void __fastcall RequestReceived(Scktcomp::TServerClientThread* ClientThread, Ddodocument::TDDODocument* Request, Ddodocument::TDDODocument* &Result);
	void __fastcall StubCreated(TDDOStubBase* Stub);
	virtual void __fastcall Loaded(void);
	__property Classes::TList* Classes = {read=FClasses};
	__property Ddosockets::TDDOServerSocket* Socket = {read=FSocket};
	
public:
	void __fastcall EnumStubs(TMetaClass* StubClass, TEnumStubCallback Callback, int UserData);
	__fastcall virtual TDDOListener(Classes::TComponent* Owner);
	__fastcall virtual ~TDDOListener(void);
	void __fastcall RegisterClass(TMetaClass* DDOClass);
	void __fastcall UnregisterClass(TMetaClass* DDOClass);
	__property int ActiveThreads = {read=GetActiveThreads, nodefault};
	__property int IdleThreads = {read=GetIdleThreads, nodefault};
	__property int MaxThreads = {read=FMaxThreads, nodefault};
	__property int ActiveConnections = {read=GetActiveConnections, nodefault};
	__property Scktcomp::TCustomWinSocket* Connections[int Index] = {read=GetConnection};
	__property int ClassCount = {read=GetClassCount, nodefault};
	__property TMetaClass* StubClass[int Index] = {read=GetStubClass};
	__property int ActiveStubs = {read=GetActiveStubs, nodefault};
	__property int Requests = {read=FRequests, nodefault};
	
__published:
	__property bool Active = {read=GetActive, write=SetActive, nodefault};
	__property TClientAccess ClientAccess = {read=FClientAccess, write=SetClientAccess, default=0};
	__property int Port = {read=FPort, write=SetPort, default=6666};
	__property int ThreadCacheSize = {read=GetThreadCacheSize, write=SetThreadCacheSize, default=15};
	__property Byte ThreadTimeOut = {read=FThreadTimeOut, write=FThreadTimeOut, default=15};
	__property Byte SessionTimeOut = {read=FSessionTimeOut, write=FSessionTimeOut, default=30};
	__property Ddobase::TDataEvent OnDataEvent = {read=FOnDataEvent, write=FOnDataEvent};
	__property Ddobase::TRequestEvent OnRequestReceived = {read=FOnRequestReceived, write=FOnRequestReceived};
	__property Ddobase::TResultEvent OnRequestProcessed = {read=FOnRequestProcessed, write=FOnRequestProcessed};
	__property TClientException OnClientException = {read=FOnClientException, write=FOnClientException};
	__property Classes::TNotifyEvent OnActivate = {read=FOnActivate, write=FOnActivate};
	__property Classes::TNotifyEvent OnDeactivate = {read=FOnDeActivate, write=FOnDeActivate};
	__property TStubCreatedEvent OnStubCreated = {read=FOnStubCreated, write=FOnStubCreated};
	__property bool UseSSL = {read=FUseSSL, write=SetUseSSL, nodefault};
	__property bool KeepAlive = {read=FKeepALive, write=FKeepALive, nodefault};
	__property bool CheckVersion = {read=FCheckVersion, write=FCheckVersion, nodefault};
};


class PASCALIMPLEMENTATION TDDOListenerThread : public Ddosockets::TDDOServerClientThread 
{
	typedef Ddosockets::TDDOServerClientThread inherited;
	
private:
	Ddodocument::TDDODocument* FRequest;
	Ddodocument::TDDODocument* FAnswer;
	TDDOListener* FListener;
	System::TDateTime FLastActive;
	bool FDropped;
	void __fastcall FreeDocuments(void);
	void __fastcall DoRequestReceived(void);
	void __fastcall DoRequestProcessed(void);
	void __fastcall FreeNotification(System::TObject* Sender);
	
protected:
	virtual void __fastcall HandleException(void);
	virtual void __fastcall HandleRequest(void);
	
public:
	__fastcall TDDOListenerThread(Scktcomp::TServerClientWinSocket* ASocket, TDDOListener* AListener);
	__fastcall virtual ~TDDOListenerThread(void);
	__property System::TDateTime LastActive = {read=FLastActive};
};


class PASCALIMPLEMENTATION TDDOStubBase : public Ddobase::TDDOBase 
{
	typedef Ddobase::TDDOBase inherited;
	
private:
	Ddodocument::TDDODocument* FRequest;
	Ddodocument::TDDODocument* FResult;
	TDDOListener* FListener;
	AnsiString FObjectID;
	Ddosystem::TDDOCriticalSection* FLock;
	TDDOSession* FDDOSession;
	Scktcomp::TServerClientWinSocket* FSocket;
	Classes::TList* FFreeMem;
	Contnrs::TObjectList* FFreeObj;
	__property Scktcomp::TServerClientWinSocket* Socket = {read=FSocket, write=FSocket};
	/*         class method */ static Ddodocument::TDDODocument* __fastcall ProcessRequest(TMetaClass* vmt, TDDOListener* Listener, Ddodocument::TDDODocument* Request, Scktcomp::TServerClientWinSocket* Socket);
	void __fastcall InitializeCall(TDDOListener* Listener, Ddodocument::TDDODocument* ARequest);
	bool __fastcall GetActive(void);
	AnsiString __fastcall GetRemoteHost();
	int __fastcall GetRemotePort(void);
	void __fastcall CleanupMem(void);
	
protected:
	System::TDateTime FLastAccess;
	void * __fastcall FreeAfterProcessing(System::TObject* AObject)/* overload */;
	void * __fastcall FreeAfterProcessing(void * APointer)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOInt64Array &Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOInt64Array Value)/* overload */;
	HIDESBASE void __fastcall AddEmptyArrayNode(const AnsiString Name);
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ WideString &Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, const WideString Value)/* overload */;
	HIDESBASE Variant __fastcall GetParam(const AnsiString Name, bool AsDateTime)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOShortIntArray &Value)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOWordArray &Value)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOBooleanArray &Value)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOCharArray &Value)/* overload */;
	HIDESBASE void __fastcall GetParam(const AnsiString Name, /* out */ Ddoshared::TDDOExtendedArray &Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, const Variant &Value, bool AsDateTime)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOShortIntArray Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOWordArray Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOBooleanArray Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOCharArray Value)/* overload */;
	HIDESBASE void __fastcall SetParam(const AnsiString Name, Ddoshared::TDDOExtendedArray Value)/* overload */;
	HIDESBASE Classes::TStream* __fastcall GetTStream(const AnsiString Name);
	HIDESBASE void __fastcall SetTStream(const AnsiString Name, Classes::TStream* Stream);
	HIDESBASE void * __fastcall GetRecord(const AnsiString Name, Typinfo::PTypeInfo TypeInfo, int Size);
	HIDESBASE void __fastcall SetRecord(const AnsiString Name, Typinfo::PTypeInfo TypeInfo, int Size, void * ARecord);
	HIDESBASE void __fastcall SetIDDOPersistent(const AnsiString Name, System::TObject* Value)/* overload */;
	HIDESBASE System::TObject* __fastcall GetIDDOPersistent(const AnsiString Name)/* overload */;
	virtual bool __fastcall InternalDispatch(const AnsiString MethodName);
	virtual void __fastcall DispatchCall(const AnsiString MethodName) = 0 ;
	void __fastcall Enter(void);
	bool __fastcall TryEnter(void);
	void __fastcall Leave(void);
	__property bool Active = {read=GetActive, nodefault};
	__property AnsiString ObjectID = {read=FObjectID};
	__property TDDOListener* Listener = {read=FListener};
	__property AnsiString RemoteHost = {read=GetRemoteHost};
	__property int RemotePort = {read=GetRemotePort, nodefault};
	__property Ddodocument::TDDODocument* Request = {read=FRequest};
	__property Ddodocument::TDDODocument* Result = {read=FResult};
	__property System::TDateTime LastAccess = {read=FLastAccess};
	__property TDDOSession* Session = {read=FDDOSession};
	
public:
	__fastcall virtual TDDOStubBase(const AnsiString ObjectID);
	virtual void __fastcall AfterConstruction(void);
	virtual void __fastcall Initialize(void);
	__fastcall virtual ~TDDOStubBase(void);
	/* virtual class method */ virtual int __fastcall TimeOut(TMetaClass* vmt);
	/* virtual class method */ virtual Ddobase::TClassState __fastcall State(TMetaClass* vmt);
	/* virtual class method */ virtual AnsiString __fastcall GetVersion(TMetaClass* vmt);
	/*         class method */ static AnsiString __fastcall GetXML(TMetaClass* vmt);
	
/* Hoisted overloads: */
	
protected:
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOInt64Array &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline Variant __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, bool AsDateTime){ return TDDOBase::GetParam(Document, Name, AsDateTime); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ WideString &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOShortIntArray &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOWordArray &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOBooleanArray &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOCharArray &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  GetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, /* out */ Ddoshared::TDDOExtendedArray &Value){ TDDOBase::GetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOInt64Array Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, const WideString Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, System::PVariant Value, bool AsDateTime){ TDDOBase::SetParam(Document, Name, Value, AsDateTime); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOShortIntArray Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOWordArray Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOBooleanArray Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOCharArray Value){ TDDOBase::SetParam(Document, Name, Value); }
	inline void __fastcall  SetParam(Ddodocument::TDDODocument* Document, const AnsiString Name, Ddobase::PDDOExtendedArray Value){ TDDOBase::SetParam(Document, Name, Value); }
	
};


class DELPHICLASS TDDOServerUtils;
class PASCALIMPLEMENTATION TDDOServerUtils : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	/*         class method */ static Classes::TList* __fastcall LockStubs(TMetaClass* vmt);
	/*         class method */ static void __fastcall UnlockStubs(TMetaClass* vmt);
	/*         class method */ static Classes::TList* __fastcall LockListeners(TMetaClass* vmt);
	/*         class method */ static void __fastcall UnlockListeners(TMetaClass* vmt);
	/*         class method */ static Ddousage::TDDOStubTracker* __fastcall GetStubTracker(TMetaClass* vmt);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TDDOServerUtils(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDDOServerUtils(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Ddodocument::TDDODocument* __fastcall CreateExceptionDocument(Sysutils::Exception* E);

}	/* namespace Ddoserver */
using namespace Ddoserver;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DDOServer
